#!/usr/bin/perl

########################################################################
#
# COPYRIGHT NOTICE:
#
# Copyright 2007 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent
# from FocalMedia.Net is expressly forbidden. You may not
# redistribute this program in any shape or form.
#
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability
# of FocalMedia.Net for any damages, losses and/or causes of action
# exceed the total amount paid by the user for this software.
#
########################################################################


package acs;

#use FindBin;
#use lib $FindBin::Bin;

use Time::localtime;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use Time::Local;
use DBI;
use File::stat;


require Exporter;

use vars qw/@ISA @EXPORT @EXPORT_OK $copyright $prgname/;

@ISA = qw(Exporter);

@EXPORT = qw(update_comment_nrs
				 recount_kbcat_links
				 get_admin_menu
				 check_access
				 problem_popup
				 continue_popup
				 no_access
				 get_user_ticket_no
				 get_age
				 send_email
				 get_staff_name
				 decode_ticket
				 get_file_contents
				 decode_tags
				 decode_date
				 new_tsettings
				 insert_template_includes
				 get_ver
				 get_atemplate
				 adm_problem_popup
				 adm_continue_popup
				 get_heading_box);

@EXPORT_OK = qw($return_tn
					 $admenu
					 $real_name
					 $suserid
					 $rtno
					 $thefile
					 $msg_whole
					 $rdvalue
					 $this
					 $tmpl_page
					 $deskver);

&get_setup;


$tht = time();
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = gmtime($tht);
$year = $year + 1900;

$desk_copyright = "Copyright \@ $year FocalMedia.Net";
$desk_ver = "ActivDesk Ver 3.0";
$orderurl = "http://www.focalmedia.net/activdesk_order.html";

############################################################################


sub get_heading_box
{

my ($h_icon, $h_heading, $h_text) = @_;

$h_return = qq[<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
 <tr>
  <td width="1%" valign="top" bgcolor="#FFFFFF"><img src="$h_icon"></td>
  <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
 <tr>
  <td background="$web_url/bar6.gif" class="normaltext"><strong>$h_heading</strong></td>
 </tr>
 <tr>
  <td class="normaltext">$h_text</td>
 </tr>
</table></td></tr></table>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr><td height="20"></td>
  </tr>
</table>
];

return ($h_return);

#<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
#  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
#</table>

}


sub get_atemplate
{

$ret_templ = qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>ActivDesk</title>
<link href="$web_url/adesk.css" rel="stylesheet" type="text/css">
</head>
<body>
<table width="96%" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td><img src="$web_url/admlogo.jpg" /><br />    </td>
  </tr>
</table>
<table width="93%" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td colspan="3">!!amenu!!</td>
  </tr>
</table>
<table width="96%" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%"><img src="$web_url/cr1.gif" /></td>
    <td width="100%" background="$web_url/cr2.gif" /></td>
    <td width="1%"><img src="$web_url/cr3.gif" /></td>
  </tr>
</table>
<table width="96%" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%" background="$web_url/cr4.gif"><img src="$web_url/cr4.gif" width="16" height="5" /></td>
    	<td width="100%" valign="top" bgcolor="#FFFFFF" />
    	<table width="100%" border="0" cellpadding="6" cellspacing="1">
		  <tr>
		    <td>!!data!!</td>
		  </tr>
		</table>
    	</td>
    <td width="1%" background="$web_url/cr5.gif"><img src="$web_url/cr5.gif" width="14" height="6" /></td>
  </tr>
</table>
<table width="96%" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%"><img src="$web_url/cr6.gif" width="21" height="35" /></td>
    <td width="100%" background="$web_url/cr7.gif" /></td>
    <td></td></td>
    <td width="1%"><img src="$web_url/cr8.gif" /></td>
  </tr>
</table>
</body>
</html>
];

return ($ret_templ);

}


sub get_ver
{
$deskver = $desk_ver;
@ssd = split (/ /, $deskver);
return ($ssd[0]);
}


sub insert_template_includes
{

my ($tmpl_page, $ce_username, $ce_password) = @_;

opendir(DIR,"$data_dir");
@files = readdir(DIR);
closedir(DIR);

if ($tmpl_page =~ /%%incl_/)
	{
	foreach $ifilen (@files)
		{
		if (substr($ifilen, 0, 5) eq "incl_")
			{
			$incl = $ifilen;
			$incl =~ s/\.html//g;
			$incl = "%%" . $incl . "%%";

				if ($tmpl_page =~ /$incl/)
					{
					$theincl = &get_file_contents ("$data_dir/$ifilen");
					$tmpl_page =~ s/$incl/$theincl/g;
					}

			}
		}
	}


$tmpl_page =~ s/!!web_url!!/$web_url/g;
$tmpl_page =~ s/!!scripts_url!!/$script_url/g;
$tmpl_page =~ s/!!login!!/$script_url\/login\.cgi/g;
$tmpl_page =~ s/!!register!!/$script_url\/register\.cgi/g;
$tmpl_page =~ s/!!kb!!/$script_url\/fp\.cgi/g;
$tmpl_page =~ s/!!lostps!!/$script_url\/lostps\.cgi/g;

$tmpl_page =~ s/!!search_script!!/$script_url\/search\.cgi/g;
$tmpl_page =~ s/!!advanced!!/$script_url\/search\.cgi\?fct=advanced/g;
$tmpl_page =~ s/!!tofrontpage!!/$script_url\/fp\.cgi/g;




if ($tmpl_page =~ /%%search_in%%/)
	{
   $copti = &get_file_contents ("$data_dir/coptions.dat");
   $tmpl_page =~ s/%%search_in%%/$copti/gi;
	}

if (($ce_username ne "") and ($ce_password ne ""))
	{
	$tmpl_page =~ s/!!home!!/$script_url\/login\.cgi\?fct=do_login&u=$ce_username&p=$ce_password/g;
	$tmpl_page =~ s/!!new_ticket!!/$script_url\/login2\.cgi\?fct=new_ticket&u=$ce_username&p=$ce_password/g;
	$tmpl_page =~ s/!!kb!!/$script_url\/kb\.cgi/g;
	$tmpl_page =~ s/!!edit_details!!/$script_url\/login4\.cgi\?fct=edit_details&u=$ce_username&p=$ce_password/g;
	}


#$tmpl_page =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;

return ($tmpl_page);

}





sub new_tsettings
{
my $this = {};

$scnts = &get_file_contents("$data_dir/tsettings.dat");
@all_obj_items = split (/\n/, $scnts);

foreach $obji (@all_obj_items)
	{
	($obj_prp, $obj_val) = split (/=/, $obji);
	$this->{$obj_prp} = $obj_val;
	}

bless $this;
return $this;
}




sub decode_date
{

my ($tvalue) = @_;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst,@marray, $rdvalue, $ampm);

open (GSETT, "$data_dir/gsettings.dat");
	@conflines = <GSETT>;
close (GSETT);
$dateformat = $conflines[48];
chop($dateformat);


($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($tvalue);
$year = "20" . substr($year, 1, 2);
@marray = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

if (length($min) == 1) {$min = "0" . $min;}
if (length($min) == 1) {$min = "0" . $min;}

if ($hour == 0){$hour = 12;}

$rdvalue = "$marray[$mon] $mday, $year";

#print "==>$dateformat $rdvalue <BR>";

return ($rdvalue);

}





sub decode_tags
{
my ($msg_whole) = @_;

$msg_whole =~ s/\[black\]/<font color="#000000">/gi; ### BLACK
$msg_whole =~ s/\[\/black\]/<\/font>/gi;

$msg_whole =~ s/\[Silver\]/<font color="#C0C0C0">/gi; ### Silver
$msg_whole =~ s/\[\/Silver\]/<\/font>/gi;

$msg_whole =~ s/\[Red\]/<font color="#FF0000">/gi; ### Red
$msg_whole =~ s/\[\/Red\]/<\/font>/gi;

$msg_whole =~ s/\[lpurple\]/<font color="#FF00FF">/gi; ### Light Purple
$msg_whole =~ s/\[\/lpurple\]/<\/font>/gi;

$msg_whole =~ s/\[Blue\]/<font color="#0000FF">/gi; ### Blue
$msg_whole =~ s/\[\/Blue\]/<\/font>/gi;

$msg_whole =~ s/\[Aqua\]/<font color="#00FFFF">/gi; ### Aqua
$msg_whole =~ s/\[\/Aqua\]/<\/font>/gi;

$msg_whole =~ s/\[Lime\]/<font color="#00FF00">/gi; ### Lime
$msg_whole =~ s/\[\/Lime\]/<\/font>/gi;

$msg_whole =~ s/\[Yellow\]/<font color="#FFFF00">/gi; ### Yellow
$msg_whole =~ s/\[\/Yellow\]/<\/font>/gi;

$msg_whole =~ s/\[White\]/<font color="#FFFFFF">/gi; ### White
$msg_whole =~ s/\[\/White\]/<\/font>/gi;

$msg_whole =~ s/\[Gray\]/<font color="#C0C0C0">/gi; ### Gray
$msg_whole =~ s/\[\/Gray\]/<\/font>/gi;

$msg_whole =~ s/\[Maroon\]/<font color="#800000">/gi; ### Maroon
$msg_whole =~ s/\[\/Maroon\]/<\/font>/gi;

$msg_whole =~ s/\[Purple\]/<font color="#800080">/gi; ### Purple
$msg_whole =~ s/\[\/Purple\]/<\/font>/gi;

$msg_whole =~ s/\[Navy\]/<font color="#000080">/gi; ### Navy
$msg_whole =~ s/\[\/Navy\]/<\/font>/gi;

$msg_whole =~ s/\[Teal\]/<font color="#008080">/gi; ### Teal
$msg_whole =~ s/\[\/Teal\]/<\/font>/gi;

$msg_whole =~ s/\[Green\]/<font color="#008000">/gi; ### Green
$msg_whole =~ s/\[\/Green\]/<\/font>/gi;

$msg_whole =~ s/\[Olive\]/<font color="#808000">/gi; ### Olive
$msg_whole =~ s/\[\/Olive\]/<\/font>/gi;


#### IMAGES
$HTMLstart = "<img src=\"";
$HTMLend = "\">";

$msg_whole =~ s/\[image\]/$HTMLstart/gi;
$msg_whole =~ s/\[\/image\]/$HTMLend/gi;

#### BOLD
$msg_whole =~ s/\[b\]/<b>/gi;
$msg_whole =~ s/\[\/b\]/<\/b>/gi;


#### URLS
$excount = 0;
while ($msg_whole =~ /\[url\]/)
	{
	$urlstring = "";

	$msg_whole =~ m/\[url\]/gi;
	$istart = pos($msg_whole);

	$msg_whole =~ m/\[\/url\]/gi;
	$iend = pos($msg_whole);

	$urlstring = substr($msg_whole, $istart, ($iend - $istart - 6));

	$urlstring = "<a href=\"$urlstring\">";

	$msg_whole =~ s/\[url\]/$urlstring/i;
	$msg_whole =~ s/\[\/url\]/<\/a>/i;

	$excount++;
	if ($excount == 100) { $msg_whole =~ s/\[url\]//gi; }
	}


$excount = 0;
while ($msg_whole =~ /\[url=/)
	{

	$msg_whole =~ m/\[url=/gi;
	$istart = pos($msg_whole);

	$msg_whole =~ m/\]/gi;
	$iend = pos($msg_whole);

	$urlstring = substr($msg_whole, $istart, ($iend - $istart - 1));

	$msg_whole =~ m/\[\/url\]/gi;
	$iend2 = pos($msg_whole);

	$textstring = substr($msg_whole, $iend, ($iend2 - $iend - 6));

	#$urlstring2 = "<a href=\"$urlstring\" target=\"_blank\">";
	#$msg_whole =~ s/\[url=$urlstring\]/$urlstring2/i;
	#$msg_whole =~ s/\[\/url\]/<\/a>/i;

	$urlstring2 = "<a href=\"";
	$urlsclose = "\" target=\"_blank\">";

	$msg_whole =~ s/\[url=/$urlstring2/i;
	$msg_whole =~ s/\]/$urlsclose/i;
	$msg_whole =~ s/\[\/url\]/<\/a>/i;

	$excount++;
	if ($excount == 100) { $msg_whole =~ s/\[url=//gi; }
	}


return ($msg_whole);
}





sub update_comment_nrs
{

($tval, $tkid) = @_;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "UPDATE support_kb SET comnr = comnr $tval WHERE kid = '$tkid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect;

}




sub recount_kbcat_links
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

### GET 2ND LEVEL CATEGORY IDS


$sql = "SELECT * FROM support_kbcats ORDER BY l1";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	$ac = 0; $ac2 = 0;
	while ( @row = $sth->fetchrow() )
		{
		if ($row[3] ne "")
			{
			$kcid[$ac] = $row[0]; $ac++;
			#print "$row[0]:$row[1] - $row[2] / $row[3] --- <BR>";
			}
			else
			{
			$kcidroot[$ac2] = $row[0]; $ac2++;
			}
		}

### COUNT LINKS 2ND LEVEL
$cc = 0;
foreach $item (@kcid)
	{
	$sql = "SELECT count(*) FROM support_kb WHERE kcid = '$item' ";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	while ( @row = $sth->fetchrow() )
		{
		$kcid[$cc] = $item . ":" . $row[0];
		#print "$kcid[$cc]<BR>";
		$cc++;
		}

	}

### UPDATE 2ND LEVEL NUMBERS
$sql = qq{UPDATE support_kbcats SET  l2_nr = ?
												 WHERE
												 kcid = ?
			 };

$sth = $dbh->prepare($sql);
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

foreach $item (@kcid)
	{
	($t_cid, $t_nr) = split (/:/, $item);

	$sth->bind_param(1, $t_nr); 			### number of links
	$sth->bind_param(2, $t_cid); 			### cat id

   $sth->execute;
	}

### UPDATE 1ST LEVEL NUMBERS

foreach $item (@kcidroot)
	{

	$sql = "SELECT count(*) FROM support_kb WHERE kcid = '$item' ";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

		while ( @row = $sth->fetchrow() )
		{
		$main_level_count = $row[0];
		}

		### GET SUB CATEGORY LINK NUMBERS

		$sql = "SELECT l2_nr FROM support_kbcats WHERE kccid = '$item' ";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

		while ( @row = $sth->fetchrow() )
		{
		$main_level_count = $main_level_count + $row[0];
		}

		##UPDATE 1ST LEVEL NUMBERS

		$sql = "UPDATE support_kbcats SET  l1_nr = '$main_level_count' WHERE kcid = '$item'";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	}

$sth->finish;
$dbh->disconnect;

}



sub decode_ticket
{
my ($ticketno) = @_;

$suserid = substr($ticketno, length($ticketno) - 7, 7);
$suserid = int($suserid);

$rtno = substr($ticketno, 0, length($ticketno) - 7);

return ($suserid, $rtno);
}




sub get_staff_name
{

$query = new CGI;
$usercookie = $query->cookie('nuser');
$passcookie = $query->cookie('npass');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT fullname FROM support_staff WHERE username = '$usercookie'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

	while ( @row = $sth->fetchrow() )
	{
	$real_name = $row[0];
	}

$sth->finish;
$dbh->disconnect;

return ($real_name);

}



sub get_admin_menu
{
my ($buttonba) = @_;


$ad_home = qq[<a href="$admin_url/admin8.cgi" id="a_homebut"><span>Home</span></a>];

$ad_smanager = qq[<a href="$admin_url/admin8.cgi?fct=manage_supportstaff" id="adh_sman"><span>Support Staff Manager</span></a>];

$ad_catman = qq[<a href="$admin_url/admin10.cgi?fct=admin_cat" id="adh_catman"><span>Category Manager</span></a>];

$ad_email = qq[<a href="$admin_url/admin10.cgi?fct=cust_emails" id="adh_email"><span>Customize Email</span></a>];

$ad_settings = qq[<a href="$admin_url/admin10.cgi?fct=settings" id="adh_settings"><span>Settings</span></a>];


if ($buttonba eq "HOME")
	{
    $ad_home = qq[<a href="$admin_url/admin10.cgi?fct=admin_cat"><img src="$web_url/mn5.gif" border="0"></a>];
 	}
	elsif ($buttonba eq "STAFF")
	{
    $ad_smanager = qq[<a href="$admin_url/admin8.cgi?fct=manage_supportstaff"><img src="$web_url/mn1_2.gif" border="0"></a>];
	}
	elsif ($buttonba eq "CAT")
	{
	$ad_catman = qq[<a href="$admin_url/admin10.cgi?fct=admin_cat"><img src="$web_url/mn2_2.gif" border="0"></a>];
	}
	elsif ($buttonba eq "CEMAIL")
	{
	$ad_email = qq[<a href="$admin_url/admin10.cgi?fct=cust_emails"><img src="$web_url/mn3_2.gif" border="0"></a>];
	}
	elsif ($buttonba eq "SETTINGS")
	{
	$ad_settings = qq[<a href="$admin_url/admin10.cgi?fct=settings"><img src="$web_url/mn4_2.gif" border="0"></a>];
	}


$admenu = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%">$ad_home</td>
    <td width="1%">$ad_smanager</td>
    <td width="1%">$ad_catman</td>
    <td width="1%">$ad_email</td>
    <td width="96%">$ad_settings</td>
  </tr>
</table>
];

return ($admenu);

}



sub get_age
{
my ($the_date) = @_;

($sdate, $stime) = split (/ /,$the_date);

($shour, $smin, $ssec) = split (/:/, $stime);
($syear, $smon, $sday) = split (/-/, $sdate);
$smon = $smon -1;

$time = timelocal($ssec,$smin,$shour, $sday,$smon,$syear);
$nowtime = time();

##
$age_seconds = $nowtime - $time;
##

### get days
if ($age_seconds > 86400)
	{
	$oodays = ($age_seconds / 86400);
	($oodays, $tmp) = split(/\./, $oodays);
	}
	else
	{
	$oodays = 0;
	}


### get remaning hours
if ($oodays > 0)
	{
	$totaldsecs = ($oodays * 86400);
	$hourslefts = ($age_seconds - $totaldsecs);
	$oo_hours = ($hourslefts / 3600);
	($oo_hours, $tmp) = split(/\./, $oo_hours);
	}
	else
	{
	$oo_hours = ($age_seconds / 3600);
	($oo_hours, $tmp) = split(/\./, $oo_hours);
	}

return ($oo_hours, $oodays);

}




sub get_user_ticket_no
{
my ($userno, $tnu) = @_;

if (length($userno) == 1){ $ruserno = "000000" . $userno; }
if (length($userno) == 2){ $ruserno = "00000" . $userno; }
if (length($userno) == 3){ $ruserno = "0000" . $userno; }
if (length($userno) == 4){ $ruserno = "000" . $userno; }
if (length($userno) == 5){ $ruserno = "00" . $userno; }
if (length($userno) == 6){ $ruserno = "0" . $userno; }

$return_tn = $tnu . $ruserno;

return ($return_tn);
}




sub no_access
{
print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>$desk_ver</title>
<link href="$web_url/adeskp.css" rel="stylesheet" type="text/css">
</head>

<body>

<p align="center"> <img src="$web_url/ic_lock.jpg"> </p>
<div align="center">
  <center>
    <table border="0" cellpadding="5" cellspacing="0" width="80%"  style="border: 1px solid rgb(225,225,225)">
      <tr>
        <td height="1" align="center" bgcolor="#FFFFFF" class="normaltext"><p> <strong> You Don't have access to this function </strong> </p>
          Use the back browser of your browser to go back. </td>
      </tr>
    </table>
  </center>
</div>

</body>
</html>
];

exit;
}




sub adm_continue_popup
{

my ($co_text, $othertext, $conti) = @_;


if ($conti ne "")
	{
	$adminbar = &get_admin_menu($conti);
	}
	else
	{
	$adminbar = &get_admin_menu("HOME");
	}

#$adisplt

$scrtext1 = qq[
<table border="0" cellpadding="6" cellspacing="1" width="100%"  style="border: 1px solid rgb(225,225,225)">
  <tr class="bar7">
    <td ><span class="normaltext"><strong> $co_text </strong></span></td>
  </tr>
  <tr>
    <td width="460"><span class="normaltext"> $othertext <a      href="javascript:onClick=window.close()"> Close this window </a></span></td>
  </tr>
</table>

];


$atemplate = get_atemplate();
$atemplate =~ s/!!data!!/$scrtext1/gi;
$atemplate =~ s/!!amenu!!/$adminbar/gi;

print $atemplate;

}




sub continue_popup
{
my ($co_text, $othertext, $conti) = @_;


if ($conti ne "")
	{
	$adminbar = &get_admin_menu($conti);
$adisplt = qq[
<table border="0" cellpadding="0"
  cellspacing="0" width="100%">
    <tr>
      <td width="100%">$adminbar</td>
    </tr>
  </table>
];

	$backcol = "bgcolor=\"#0000A0\"";
	$fcolor = "color=\"#FFFFFF\"";
	}
	else
	{
	$backcol = "background=\"$web_url/bar.gif\"";
	}


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>$desk_ver</title>
<link href="$web_url/adeskp.css" rel="stylesheet" type="text/css">
</head>
<body>
    $adisplt


<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(225,225,225)">
      <tr class="bar6">
        <td width="460"><strong class="normaltext">$co_text </strong></td>
      </tr>
      <tr>
        <td width="460" bgcolor="#FFFFFF"> <span class="normaltext">$othertext <a      href="javascript:onClick=window.close()"> Close this window </a></span></td>
      </tr>
    </table>
</body>
</html>

];


}



sub adm_problem_popup
{

my ($problem_pop, $menutype) = @_;


if ($menutype ne "")
	{
	$adminbar = &get_admin_menu($menutype);
	}
	else
	{
	$adminbar = &get_admin_menu("HOME");
	}




$scrtext1 = qq[

    <table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(225,225,225)">
      <tr class="bar7">
        <td><span class="normaltext"><strong> Problem </strong></span></td>
      </tr>
      <tr>
        <td width="460" class="normaltext"><span class="normaltext"> $problem_pop </span></td>
      </tr>
      <tr>
        <td><span class="normaltext"><a href="" onClick="history.go(-1); return false;">Go Back</a></span></td>
      </tr>
    </table>
];



$atemplate = get_atemplate();
$atemplate =~ s/!!data!!/$scrtext1/gi;
$atemplate =~ s/!!amenu!!/$adminbar/gi;

print $atemplate;

exit;
}



sub problem_popup
{

my ($problem_text) = @_;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Problem</title>
<link href="$web_url/adeskp.css" rel="stylesheet" type="text/css">
</head>
<body>

 <table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(225,225,225)">
      <tr class="bar6">
        <td width="460"><strong class="normaltext"> Problem </strong></td>
      </tr>
      <tr>
        <td width="460" bgcolor="#FFFFFF" class="normaltext"> $problem_text </td>
      </tr>
      <tr>
        <td bgcolor="#FFFFFF"><a href="" class="normaltext" onClick="history.go(-1); return false;"><strong>Go Back</strong></a></td>
      </tr>
    </table>

</body>
</html>

];

exit;
}





sub get_template
{

my ($tbutton, $suser, $buser_man, $btemplate_man, $bsupport_tickets, $bknowledge_base) = @_;

#$template = &get_file_contents("$data_dir/control_panel2.html");

$template = qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>ActivDesk</title>
<link href="$web_url/adesk.css" rel="stylesheet" type="text/css">
<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {

   var iMyWidth;
	var iMyHeight;
	iMyWidth = (window.screen.width/2) - (75 + 10);
	iMyHeight = (window.screen.height/2) - (100 + 50);

    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=1,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + ", screenX=" + iMyWidth + ",screenY=" + iMyHeight +"'";
	 var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.focus();

    }

 function submitsearch(theForm)
   {
     var windowName = "Saerch";
     windowURL = theForm.action + '?';
     windowURL = windowURL + "keywords=" + theForm.keywords.value;
     var myspecs = "'menubar=0,status=1,resizable=1,location=1,titlebar=1,toolbar=1,scrollbars=1,width=600,height=400'";

     var popupwin = null;
     myWindow = open(windowURL, popupwin, myspecs);
     myWindow.focus();
   }

 // End Hide -->
 </script>
</head>
<body>
<table width="96%" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="45%"><img src="$web_url/toplogo.jpg" width="258" height="90" /></td>
    <td width="55%"  valign="top" align="center"><strong> <span class="normaltext">ActivDesk Control Panel <br />
      </span><span class="greydf">!!version!! </span></strong><span class="greydf"> |
      !!copyright!!
      &nbsp;&nbsp;&nbsp; <br />
      <a href="!!my_profile!!" onclick="popup('!!my_profile!!',700,400);return false;"> <img src="$web_url/myprofile.gif" border="0" /></a> <a href="!!logout!!"><img src="$web_url/logout.gif" border="0" /></a> <a href="http://www.focalmedia.net/cgi-bin/help/adesk/help.cgi"><img src="$web_url/manual.gif" border="0" /></a> </span> <br />
    </td>
  </tr>
</table>
<table width="93%" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td colspan="3">!!navbar!! </td>
  </tr>
</table>
<table width="96%" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%"><img src="$web_url/cr1.gif" /></td>
    <td width="100%" background="$web_url/cr2.gif" /></td>
    <td width="1%"><img src="$web_url/cr3.gif" /></td>
  </tr>
</table>
<table width="96%" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%" background="$web_url/cr4.gif"><img src="$web_url/cr4.gif" width="16" height="5" /></td>
    	<td width="100%" valign="top" bgcolor="#FFFFFF" />

    	<table width="100%" border="0" cellpadding="6" cellspacing="1">
		  <tr>
		    <td>!!data!!</td>
		  </tr>
		</table>

    	</td>
    <td width="1%" background="$web_url/cr5.gif"><img src="$web_url/cr5.gif" width="14" height="6" /></td>
  </tr>
</table>
<table width="96%" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%"><img src="$web_url/cr6.gif" width="21" height="35" /></td>
    <td width="100%" background="$web_url/cr7.gif" /></td>
    <td></td></td>
    <td width="1%"><img src="$web_url/cr8.gif" /></td>
  </tr>
</table>
</body>
</html>
];


$template =~ s/!!web_url!!/$web_url/g;

$exists1 = (-e "$data_dir/coptions2.dat");
if ($exists1 < 1)
	{
	open (COPT, "> $data_dir/coptions2.dat");
		print COPT "62,119,101,99,110,104,36,99,113,117,104,102,116,64,38,49,36,35,103,102,110,111,116,98,102,103,109,111,105,64,38,55,36,35,103,102,110,111,119,113,99,102,109,111,105,64,38,50,36,35,123,106,102,119,108,62,36,52,52,49,39,37,36,116,118,124,112,102,63,37,102,112,116,103,105,115,60,35,53,113,122,35,119,112,110,108,104,33,116,106,102,41,52,54,55,45,52,54,55,45,52,54,55,42,36,65,17,11,34,35,64,117,116,65,17,11,34,35,36,33,62,119,104,33,100,100,103,108,105,117,115,118,112,103,65,35,35,36,123,102,100,98,121,115,110,36,37,48,114,101,101,115,57,49,107,106,104,37,36,120,107,103,120,105,63,37,59,57,57,37,36,105,103,108,107,105,118,64,38,50,55,37,66,61,117,115,101,111,34,102,112,98,117,118,65,35,112,114,118,110,99,111,120,102,122,119,38,63,62,118,120,115,113,113,107,63,34,88,116,104,116,100,104,102,60,63,51,116,118,117,115,111,105,65,64,48,117,115,101,111,64,63,51,117,102,65,17,11,34,35,64,48,118,117,66,14,12,35,36,61,118,117,66,14,12,35,36,33,34,63,120,101,34,122,109,101,118,107,65,35,57,58,59,35,34,107,105,106,105,107,120,62,36,53,52,49,36,35,101,109,107,106,114,62,36,102,105,111,118,104,118,35,64,63,116,63,62,108,113,104,34,118,118,100,63,37,37,34,121,104,102,96,119,117,112,34,35,50,109,100,97,120,114,109,48,106,109,103,36,35,101,109,118,64,38,35,64,63,102,115,64,16,14,33,34,35,36,33,34,63,101,33,106,117,105,103,63,37,108,117,118,115,62,48,49,122,123,120,48,105,115,100,99,111,113,102,102,108,101,47,112,104,120,48,101,106,109,46,100,108,114,48,99,103,105,116,109,50,116,118,116,102,108,98,117,104,50,100,105,108,38,33,118,100,118,104,103,119,65,35,97,101,112,98,112,110,38,63,62,118,120,115,113,113,107,63,87,115,107,115,99,103,105,33,118,114,36,117,106,104,36,61,100,117,66,14,12,35,36,33,34,35,36,33,34,70,115,110,111,104,118,100,107,100,112,33,88,104,118,116,107,114,114,61,49,118,120,115,113,113,107,63,62,50,101,63,62,50,116,63,62,50,120,101,64,16,14,33,34,63,51,117,116,65,17,11,62,50,120,98,100,111,105,63" . "\n";
		print COPT "62,69,86,63,62,118,120,115,113,113,107,33,101,111,101,116,117,64,38,111,113,117,113,98,110,119,105,121,118,37,66,61,104,114,114,117,34,102,115,109,113,117,65,35,37,51,52,49,50,51,52,35,64,87,118,106,99,111,36,87,103,117,119,106,113,113,64,48,104,114,114,117,64,63,51,116,118,117,115,111,105,65," . "\n";
		print COPT "74,104,112,113,34,71,105,116,109,35,84,112,121,104,118,102,102,35,102,122,34,68,103,117,107,121,72,102,117,110,17,11,106,119,120,113,60,50,51,120,121,122,50,103,113,102,101,109,111,104,104,106,99,49,114,102,118" . "\n";
		print COPT "" . "\n";
		print COPT "62,50,102,112,102,124,66" . "\n";
		print COPT "62,119,101,99,110,104,36,99,113,117,104,102,116,64,38,49,36,35,103,102,110,111,116,98,102,103,109,111,105,64,38,55,36,35,36,33,34,35,36,33,34,35,36,100,103,111,112,116,114,100,103,106,112,106,65,35,51,37,36,120,107,103,120,105,63,37,53,49,50,40,38,33,117,119,125,109,103,64,38,99,113,117,104,102,116,61,36,50,114,123,36,116,113,111,109,101,34,117,107,99,42,53,55,52,46,53,55,52,46,53,55,52,43,37,66,14,12,35,36,61,118,117,36,100,110,100,119,116,63,37,114,112,116,112,101,109,118,104,124,117,36,65,17,11,34,35,36,33,62,119,104,33,100,100,103,108,105,117,115,118,112,103,65,35,35,36,123,102,100,98,121,115,110,36,37,48,114,101,101,115,57,49,107,106,104,37,66,61,117,115,101,111,34,102,112,98,117,118,65,35,112,114,118,110,99,111,120,102,122,119,38,63,62,118,120,115,113,113,107,63,34,87,118,106,99,111,36,87,103,117,119,106,113,113,36,70,122,115,109,115,103,103,64,48,117,119,118,112,112,106,66,61,49,118,116,98,112,65,64,48,118,103,66,14,12,35,36,61,49,119,118,63,15,13,36,33,62,119,118,33,101,111,101,116,117,64,38,111,113,117,113,98,110,119,105,121,118,37,66,14,12,35,36,33,34,63,120,101,64,87,108,102,34,119,118,106,99,111,36,119,103,117,119,106,113,113,36,112,104,35,69,100,118,108,122,69,103,118,111,33,106,100,119,33,103,123,116,106,116,104,104,47,34,63,101,33,106,117,105,103,63,37,108,117,118,115,62,48,49,122,123,120,48,105,115,100,99,111,113,102,102,108,101,47,112,104,120,48,101,106,109,46,100,108,114,48,99,103,105,116,109,50,116,118,116,102,108,98,117,104,50,100,105,108,38,63,87,115,107,115,99,103,105,33,118,114,36,117,106,104,36,100,113,112,113,102,116,102,109,98,110,35,122,102,116,118,109,112,112,35,115,103,34,68,103,117,107,121,72,102,117,110,64,48,99,65,50,33,91,114,121,33,102,114,114,40,118,35,108,98,120,104,36,117,113,35,109,111,117,119,101,109,110,35,69,100,118,108,122,69,103,118,111,33,99,106,101,106,112,35,123,105,103,113,36,122,113,120,36,118,114,106,118,98,102,104,50,33,91,114,121,33,101,100,114,33,108,120,119,117,34,120,116,104,116,100,104,102,34,119,108,106,117,35,120,115,107,100,112,33,120,104,118,116,107,114,114,33,118,114,36,117,106,104,36,100,113,112,113,102,116,102,109,98,110,35,122,102,116,118,109,112,112,49,36,66,110,111,36,122,113,120,118,33,117,104,120,117,107,113,107,116,46,35,120,106,101,110,105,117,117,47,36,117,103,112,116,109,99,119,105,33,101,120,119,117,113,112,109,123,99,119,109,112,112,118,48,33,103,119,103,47,34,122,109,109,110,35,119,117,99,124,36,106,112,35,120,98,101,119,50,33,86,107,105,33,119,115,107,115,99,103,105,33,118,100,111,102,117,35,101,99,113,120,120,33,52,35,113,106,112,120,120,102,117,35,101,111,102,35,109,116,34,100,36,116,107,112,116,109,103,35,116,115,113,102,105,116,117,49,36,61,49,119,104,63,15,13,36,33,62,50,120,115,64,16,14,61,49,119,101,99,110,104,66,14,12" . "\n";
	close (COPT);
	}
	else
	{
		if (length($swr) != 19)
		{
		$fdt = stat("$data_dir/coptions2.dat")->mtime; $fdtdisp = ctime(stat("$data_dir/coptions2.dat")->mtime);
		$nowt = time(); $noda = ctime($nowt);
		
		#print "-->file: $fdtdisp<BR>$fdt<BR>";
		#print "-->nw: $nowt<BR>$noda<BR>";
		#print "ds: 2592000<BR>";

		if ($fdt < ($nowt - 2592000))
			{
				$gsettings3 = acs::get_file_contents("$data_dir/coptions2.dat");
				my @glines = split (/\n/, $gsettings3);
				my @alltitems = split (/,/, $glines[5]);
				$cnc = 1; $tmitem = "";
			
				foreach $tmitem(@alltitems)
					{
					$cnc++;
					if ($cnc == 5){$cnc = 1;}
					$tmitem = ($tmitem - $cnc);
					$dcst = $dcst . chr($tmitem);
					}
			$navb=qq[<table width="100%%" cellspacing="0" cellpadding="0">  <tr>    <td height="30">&nbsp;</td>  </tr></table>]; $template =~ s/!!version!!/$desk_ver/gi; $template =~ s/!!copyright!!/$desk_copyright/gi;
			$template =~ s/!!navbar!!/$navb/g; $template =~ s/!!my_profile!!/http:\/\/www\.focalmedia\.net/g; $template =~ s/!!logout!!/http:\/\/www\.focalmedia\.net/g;
			$template =~ s/!!data!!/$dcst/g; $template =~ s/!!web_url!!/$web_url/g;
			print $template;
			exit;
			}
		}
	}





if (length($swr) != 19)
{
	my $gsettings3 = acs::get_file_contents("$data_dir/coptions2.dat");
	my @glines = split (/\n/, $gsettings3);
	my @alltitems = split (/,/, $glines[1]);
	$cnc = 1; $tmitem = "";

	foreach $tmitem(@alltitems)
		{
		$cnc++;
		if ($cnc == 5){$cnc = 1;}
		$tmitem = ($tmitem - $cnc);
		$dcst = $dcst . chr($tmitem);
		}
		$desk_copyright = $desk_copyright . $dcst;
}




### SUPER USER FUNCTIONS
if ($suser eq "Y")
	{
$acript = qq[
<a href="$admin_url/admin8.cgi" onClick="popup('$admin_url/admin8.cgi',900,700);return false;"><img src="$web_url/admin.gif" border="0"></a>
];

	$template =~ s/!!admin_functions!!/$acript/g;

	$buser_man = "Y";
	$btemplate_man = "Y";
	$bsupport_tickets = "Y";
	$bknowledge_base = "Y";
	}
	else
	{
	$template =~ s/!!admin_functions!!//g;
	}

####################
### DISPLAY TABS
#####################

### HOME
if ($tbutton eq "HOME")
	{

	#$navbar = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><a href="$admin_url/admin.cgi" id="homebut"><span>Home</span></a></td>];

	$navbar = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><a href="$admin_url/admin.cgi"><img src="$web_url/ab_home2.gif" border="0"></a></td>];

	if ($bsupport_tickets eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin6.cgi" id="tickets"><span>Tickets</span></a></td>]; }
	if ($buser_man eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin13.cgi" id="userm"><span>UserManager</span></a></td>]; }
	if ($btemplate_man eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin2.cgi" id="tmpl"><span>Template Manager</span></a></td>];}
	if ($bknowledge_base eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin17.cgi" id="ab_knowl"><span>KnowledgeBase<span></a></td>];}
	if ($suser eq "Y") { $navbar = $navbar . qq[<td><a href="$admin_url/admin8.cgi?fct=start2" id="afunctions"><Span>AdminFunctions</span></a></td>]; }

	$navbar = $navbar . qq[<td width="99%" align="right" class="normaltext">!!logged_in!!</td></tr></table>];
	}

### ADMINFUNCTIONS
if ($tbutton eq "ADM")
	{
	$navbar = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><a href="$admin_url/admin.cgi" id="homebut"><span>Home</span></a></td>];

	if ($bsupport_tickets eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin6.cgi" id="tickets"><span>Tickets</span></a></td>]; }
	if ($buser_man eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin13.cgi" id="userm"><span>UserManager</span></a></td>]; }
	if ($btemplate_man eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin2.cgi" id="tmpl"><span>Template Manager</span></a></td>];}
	if ($bknowledge_base eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin17.cgi" id="ab_knowl"><span>KnowledgeBase<span></a></td>];}
	if ($suser eq "Y") { $navbar = $navbar . qq[<td><a href="$admin_url/admin8.cgi?fct=start2"><img src="$web_url/ab_afunc2.gif" border="0"></a></td>]; }

	$navbar = $navbar . qq[<td width="99%" align="right" class="normaltext">!!logged_in!!</td></tr></table>];
	}


### TEMPLATE MANAGER
elsif ($tbutton eq "TEMPLATE_MANAGER")
	{
	$navbar = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><a href="$admin_url/admin.cgi" id="homebut"><span>Home</span></a></td>];

	if ($bsupport_tickets eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin6.cgi" id="tickets"><span>Tickets</span></a></td>]; }
	if ($buser_man eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin13.cgi" id="userm"><span>UserManager</span></a></td>]; }
	if ($btemplate_man eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin2.cgi"><img src="$web_url/ab_tmpl2.gif" border="0"></a></td>];}
	if ($bknowledge_base eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin17.cgi" id="ab_knowl"><span>KnowledgeBase<span></a></td>];}
	if ($suser eq "Y") { $navbar = $navbar . qq[<td><a href="$admin_url/admin8.cgi?fct=start2" id="afunctions"><Span>AdminFunctions</span></a></td>]; }

	$navbar = $navbar . qq[<td width="99%" align="right" class="normaltext">!!logged_in!!</td></tr></table>];
	}

### SUPPORT TICKETS
elsif ($tbutton eq "SUPPORT_TICKETS")
	{
	$navbar = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><a href="$admin_url/admin.cgi" id="homebut"><span>Home</span></a></td>];

	if ($bsupport_tickets eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin6.cgi"><img src="$web_url/ab_tickets2.gif" border="0"></a></td>]; }
	if ($buser_man eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin13.cgi" id="userm"><span>UserManager</span></a></td>]; }
	if ($btemplate_man eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin2.cgi" id="tmpl"><span>Template Manager</span></a></td>];}
	if ($bknowledge_base eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin17.cgi" id="ab_knowl"><span>KnowledgeBase<span></a></td>];}
	if ($suser eq "Y") { $navbar = $navbar . qq[<td><a href="$admin_url/admin8.cgi?fct=start2" id="afunctions"><Span>AdminFunctions</span></a></td>]; }

	$navbar = $navbar . qq[<td width="99%" align="right" class="normaltext">!!logged_in!!</td></tr></table>];
	}

### USER MANAGER
elsif ($tbutton eq "USER_MANAGER")
	{
	$navbar = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><a href="$admin_url/admin.cgi" id="homebut"><span>Home</span></a></td>];

	if ($bsupport_tickets eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin6.cgi" id="tickets"><span>Tickets</span></a></td>]; }
	if ($buser_man eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin13.cgi"><img src="$web_url/ab_userm2.gif" border="0"></a></td>]; }
	if ($btemplate_man eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin2.cgi" id="tmpl"><span>Template Manager</span></a></td>];}
	if ($bknowledge_base eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin17.cgi" id="ab_knowl"><span>KnowledgeBase<span></a></td>];}
	if ($suser eq "Y") { $navbar = $navbar . qq[<td><a href="$admin_url/admin8.cgi?fct=start2" id="afunctions"><Span>AdminFunctions</span></a></td>]; }

	$navbar = $navbar . qq[<td width="99%" align="right" class="normaltext">!!logged_in!!</td></tr></table>];
	}

### KNOWLEDGE BASE
elsif ($tbutton eq "KNOWLEDGE_BASE")
	{
	$navbar = qq[<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td><a href="$admin_url/admin.cgi" id="homebut"><span>Home</span></a></td>];

	if ($bsupport_tickets eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin6.cgi" id="tickets"><span>Tickets</span></a></td>]; }
	if ($buser_man eq "Y")	{ $navbar = $navbar . qq[<td><a href="$admin_url/admin13.cgi" id="userm"><span>UserManager</span></a></td>]; }
	if ($btemplate_man eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin2.cgi" id="tmpl"><span>Template Manager</span></a></td>];}
	if ($bknowledge_base eq "Y")	{$navbar = $navbar . qq[<td><a href="$admin_url/admin17.cgi"><img src="$web_url/ab_knowl2.gif" border="0"></a></td>];}
	if ($suser eq "Y") { $navbar = $navbar . qq[<td><a href="$admin_url/admin8.cgi?fct=start2" id="afunctions"><Span>AdminFunctions</span></a></td>]; }

	$navbar = $navbar . qq[<td width="99%" align="right" class="normaltext">!!logged_in!!</td></tr></table>];
	}


$query = new CGI;
$usercookie = $query->cookie('nuser');
$passcookie = $query->cookie('npass');

$template =~ s/!!navbar!!/$navbar/g;
$template =~ s/!!logged_in!!/You are logged in as: <b>$usercookie<\/b>/g;
$template =~ s/!!logout!!/$admin_url\/admin9\.cgi/g;
$template =~ s/!!my_profile!!/$admin_url\/admin11\.cgi/g;


$template =~ s/!!version!!/$desk_ver/gi;
$template =~ s/!!copyright!!/$desk_copyright/gi;

$adrt = &get_ver();
$template =~ s/!!supportdesk!!/$adrt/gi;




return ($template);

}






sub check_access
{

my ($TheUsername, $ThePassword, $EnteredUser, $EnteredPass) = @_;
my ($usercookie, $passcookie, $query);

$query = new CGI;

$usercookie = $query->cookie('nuser');
$passcookie = $query->cookie('npass');

if (($EnteredUser ne "") and ($EnteredPass ne "")) {&do_login ($EnteredUser, $EnteredPass); exit;}

if (($usercookie eq "") and ($passcookie eq "")){&login_screen;}

### SUPPORT STAFF AUTHENTICATION

if (($usercookie ne $TheUsername) or ($passcookie ne $ThePassword))
	{

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql = "SELECT username, password, admin_user, user_man, template_man, support_tickets, knowledge_base, staff_id FROM support_staff WHERE username = '$usercookie' AND password = '$passcookie'";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

		while ( @row = $sth->fetchrow() )
		{

		$staff_id_r = $row[7];

		$TheUsername = $row[0];
		$ThePassword = $row[1];

		if ($row[2] eq "Y"){ $admin_user = "Y"; } ### SUPER USER ACCESS
		if ($row[3] eq "Y"){ $user_man = "Y"; } 	### ACCESS TO USER MANAGER
		if ($row[4] eq "Y"){ $template_man = "Y"; } ### ACCESS TO TEMPLATE MANAGER
		if ($row[5] eq "Y"){ $support_tickets = "Y"; } ### ACCESS TO SUPPORT TICKETS
		if ($row[6] eq "Y"){ $knowledge_base = "Y"; } ### ACCESS TO KNOWLEDGE BASE
		}

	$sth->finish;
	$dbh->disconnect;
	}


#	if (length($swr) != 19){ ($device,$inode,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = lstat("$data_dir/coptions2.dat");
#
#	print "Content-type: text/html\n\n";
#	print "-> $ctime - $tht";
#
#	if ((-e "$data_dir/coptions2.dat") > 0)
#		{
#		if (($ctime + 2592000) < $tht){&xpm;}}
#		}

#######
if (($usercookie ne $TheUsername) or ($passcookie ne $ThePassword)){&wrongps_screen;}

if (($usercookie eq $username) and ($passcookie eq $password))
	{
	$admin_user = "Y";
	}

	#print "Content-type: text/html\n\n";
	#print "-oo> $admin_user, $user_man, $template_man, $support_tickets, $knowledge_base, $staff_id_r <RB>";

return($admin_user, $user_man, $template_man, $support_tickets, $knowledge_base, $staff_id_r);
}






sub do_login
{

my ($form_username, $form_password) = @_;

my ($query, $thecookie1, $thecookie2, $scripts_admin);

$query = new CGI;

$thecookie1 = $query->cookie(-name=>'nuser',
			    					  -value=>$form_username,
			    					  -expires=>'+3M',
			    					  -path=>'/');

$thecookie2 = $query->cookie(	-name=>'npass',
			    						-value=>$form_password,
			    						-expires=>'+3M',
			    						-path=>'/');

print $query->header(-cookie=>[$thecookie1, $thecookie2]);

#print "Content-type: text/html\n\n";

print "<html>
<head>
<title>ActivDesk</title>
<meta HTTP-EQUIV=\"REFRESH\" CONTENT=\"0;URL=$admin_url/admin.cgi\">
</head>
<body>
</body>
</html>
";

exit;

}



sub login_screen
{

my ($newquery, $scripts_admin);
my $newquery = CGI->new;


print $newquery->header();
print $newquery->start_html("Control Panel");


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Control Panel</title>
</head>
<body>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<form method="POST" action="$admin_url/admin.cgi">
  <div align="center"><center><table border="0" cellpadding="5" cellspacing="0" width="300"
  style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td width="350" height="1"><font color="#FFFFFF" face="Verdana" size="2"><strong>__</strong></font></td>
      <td width="350" height="1"></td>
    </tr>
    <tr>
      <td width="350" height="1"><div align="right"><p><font face="Verdana" size="2"><strong>User
      Name:</strong></font></td>
      <td width="350" height="1"><input type="text" name="username" size="20"></td>
    </tr>
    <tr>
      <td width="350" height="1"><div align="right"><p><font face="Verdana" size="2"><strong>Password:
      </strong></font></td>
      <td width="350" height="1"><input type="password" name="password" size="20"></td>
    </tr>
    <tr>
      <td width="350" height="1"></td>
      <td width="350" height="1"><input type="submit" value="Login" name="B1"><br>
      <font color="#FFFFFF">__</font></td>
    </tr>
  </table>
  </center></div>
</form>

<p>&nbsp;</p>
</body>
</html>

];


exit;

}





sub wrongps_screen
{

my ($scripts_admin);

my $query = CGI->new;
print $query->header();
print $query->start_html("Control Panel");


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Control Panel</title>
</head>

<body>

<p>&nbsp;</p>

<p>&nbsp;</p>

<p>&nbsp;</p>

<form method="POST" action="$admin_url/admin.cgi">
  <div align="center"><center><p><font face="Verdana" size="2"><strong>The user name or
  password you entered was incorrect.</strong> Please Retry.</font></p>
  </center></div><div align="center"><center><table border="0" cellpadding="5"
  cellspacing="0" width="300" style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td width="350" height="1"><font color="#FFFFFF" face="Verdana" size="2"><strong>__</strong></font></td>
      <td width="350" height="1"></td>
    </tr>
    <tr>
      <td width="350" height="1"><div align="right"><p><font face="Verdana" size="2"><strong>User
      Name:</strong></font></td>
      <td width="350" height="1"><input type="text" name="username" size="20"></td>
    </tr>
    <tr>
      <td width="350" height="1"><div align="right"><p><font face="Verdana" size="2"><strong>Password:
      </strong></font></td>
      <td width="350" height="1"><input type="password" name="password" size="20"></td>
    </tr>
    <tr>
      <td width="350" height="1"></td>
      <td width="350" height="1"><input type="submit" value="Login" name="B1"><br>
      <font color="#FFFFFF">__</font></td>
    </tr>
  </table>
  </center></div>
</form>

<p>&nbsp;</p>
</body>
</html>

];


exit;

}




sub send_email
{
my($sendername1, $fromemail1, $toemail1, $mail_subject1, $email_message1) = @_;

if ($mail_method eq "smtp")
	{
	&send_mail_smtp($toemail1, $fromemail1, $sendername1, $mail_subject1, $email_message1, $smtp_server);
	}
	else
	{
	&send_mail_sendmail ($sendername1, $fromemail1, $toemail1, $mail_subject1, $email_message1);
	}

}






sub send_mail_sendmail
{

# REQUIRES
#  - location of sendmail
#  - name
#  - from email
#  - to email address
#  - subject
#  - message

my($sendername, $fromemail, $toemail, $mail_subject, $email_message) = @_;
my ($ftext);


$dcst = "";
if (length($swr) != 19)
{
	$gsettings3 = acs::get_file_contents("$data_dir/coptions2.dat");
	@glines = split (/\n/, $gsettings3);
	@alltitems = split (/,/, $glines[2]);
	$cnc = 1;

	foreach $tmitem(@alltitems)
		{
		$cnc++;
		if ($cnc == 5){$cnc = 1;}
		$tmitem = ($tmitem - $cnc);
		$dcst = $dcst . chr($tmitem);
		}
		$email_message = $email_message . "\n\n$dcst\n\n";
}


$sendername =~ s/\n//g;
$fromemail =~ s/\n//g;
$toemail =~ s/\n//g;
$mail_subject =~ s/\n//g;

### check for attacks

$toemail =~ s/\;//g;
$toemail =~ s/^\s+//g;
$toemail =~ s/\s+$//g;
if ($toemail =~ /^\S+\@\S+$/)
{
$ftext = "<" . "$fromemail" . ">";

open (SENDMAIL, "| $sendmail $toemail");
print SENDMAIL qq[From: $sendername $ftext
To: $toemail
Reply-To: $fromemail
Subject: $mail_subject
Sender: $fromemail

$email_message

];
}
}






sub send_mail_smtp
{
my ($to_email, $from_email, $from_name, $email_subject, $email_msg, $smtp_server_ss) = @_;


$dcst = "";
if (length($swr) != 19)
{
	$gsettings3 = acs::get_file_contents("$data_dir/coptions2.dat");
	@glines = split (/\n/, $gsettings3);
	@alltitems = split (/,/, $glines[2]);
	$cnc = 1;

	foreach $tmitem(@alltitems)
		{
		$cnc++;
		if ($cnc == 5){$cnc = 1;}
		$tmitem = ($tmitem - $cnc);
		$dcst = $dcst . chr($tmitem);
		}
		$email_msg = $email_msg . "\n\n$dcst\n\n";
}


$remote = IO::Socket::INET->new(
 										Proto => "tcp",
                              PeerAddr  => $smtp_server_ss,
                              PeerPort  => 25
                                 );

        unless ($remote)
        		{
        		print "Connection failed when trying to connect to $smtp_server_ss";
        		$TCPconnect = "False";
        		exit;
        		}

if ($TCPconnect ne "False")
	{

   $remote->autoflush(1);

	send($remote, "HELO localhost\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /220/) { $remote_error = $buffer; }
	#print "HELO localhost -> $buffer <Br><Br>";

	if ($remote_error eq "")
	{
	send($remote, "MAIL From: <$from_email>\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /250/) { $remote_error = $buffer; }
	#print "MAIL From [$from_email] -> $buffer <Br><Br>";
	}

	if ($remote_error eq "")
	{
	send($remote, "RCPT To: <$to_email>\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /250/) { $remote_error = $buffer; }
	#print "RCPT To: [$to_email] -> $buffer <Br><Br>";
	}

	if ($remote_error eq "")
	{
	send($remote, "DATA\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /250/) { $remote_error = $buffer; }
	#print "DATA -> $buffer <Br><Br>";
	}

	send($remote, "From: $from_email\n", 0); # was $from_name
	send($remote, "Subject: $email_subject\n", 0);

	send($remote, $email_msg, 0);

	send($remote, "\r\n.\r\n", 0);
	send($remote, "QUIT\n", 0);

close $remote;

	}

}








######################################################################

sub get_setup
{

$exists = (-e "../config.cgi");
if ($exists > 0)
	{

	open (STP, "../config.cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}

				$line =~ s/\n//g;

if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

if ($line =~ /^MAIL_METHOD/){$mail_method = &get_setup_line($line, MAIL_METHOD);}
if ($line =~ /^SENDMAIL/){$sendmail = &get_setup_line($line, SENDMAIL);}
if ($line =~ /^SMTP_SERVER/){$smtp_server = &get_setup_line($line, SMTP_SERVER);}
if ($line =~ /^SWR/){$swr = &get_setup_line($line, SWR);}

			}
	close (STP);

	}
}







sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

$filesize = (-s "$filename");
open (TFILECNTS, "$filename");
 if ($flocking ne "No"){flock (TFILECNTS,2);}
	read(TFILECNTS,$thefile,$filesize);
 if ($flocking ne "No"){flock (TFILECNTS,2);}
close (TFILECNTS);

return ($thefile);
}


1;
